#!/bin/sh

PYTHON3=`ls ~/.pyenv/versions/*/bin/python3 | tail -n 1`

MAKDO=.source/makdo_editor.py
test -f "$MAKDO" || exit 1

test -e ../makdo_mac && rm ../makdo_mac
mkdir .tmpdir
mkdir .tmpdir/makdo
cd .tmpdir

cp -p ../.source/makdo_editor.py .
mv makdo_editor.py makdo_mac.py
cp -p ../.source/makdo_md2docx.py makdo/makdo_md2docx.py
cp -p ../.source/makdo_docx2md.py makdo/makdo_docx2md.py
cp -p ../.source/makdo_mddiff.py makdo/makdo_mddiff.py
# cp -p ../.source/eblook.py makdo/eblook.py

$PYTHON3 -m venv venv
. ./venv/bin/activate
pip install --upgrade pip

pip install Pyinstaller

# pip install pywin32
pip install python-docx
pip install chardet
# pip install tkinterdnd2-universal
pip install openpyxl
pip install Levenshtein
# pip install openai
# pip install llama_cpp_python

# cp -rp venv/lib/python*/site-packages/tkinterdnd2 .

$PYTHON3 -m PyInstaller --onefile --noconsole \
	--add-data="makdo/makdo_md2docx.py:." \
	--add-data="makdo/makdo_docx2md.py:." \
	--add-data="makdo/makdo_mddiff.py:." \
	--exclude-module numpy \
	--exclude-module pandas \
	--icon=../.image/makdo_mac.icns \
	makdo_mac.py
#	--collect-data tkinterdnd2 \
#	--add-data="tkinterdnd2/tkdnd/osx-arm64:." \
#	--add-data="makdo/eblook.py:." \
#	--splash=../.image/makdo_splash.png \

deactivate

cp -p dist/makdo_mac ../../makdo_mac_arm

cd ..
rm -rf .tmpdir

cd ../
ls -s makdo_mac_arm

echo '終了します'
read -p '"Enter"を押してください' i
